/// <reference types="react" />
import { PureComponent } from "react";
import { DerivedValue } from "./reactive";
export default class Component<P = {}> extends PureComponent<P> {
    _view: DerivedValue<React.ReactNode>;
    constructor(props: P);
    willMount(props: P): void;
    componentWillMount(): void;
    didMount(props: P): void;
    componentDidMount(): void;
    willUpdate(props: P): void;
    componentWillUpdate(nextProps: P): void;
    didUpdate(props: P): void;
    componentDidUpdate(): void;
    willUnmount(props: P): void;
    componentWillUnmount(): void;
    _updating: boolean;
    _update: () => void;
    view(props: P): React.ReactNode;
    render(): React.ReactNode;
}
