"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = require("react");
var reactive_1 = require("./reactive");
var Component = (function (_super) {
    __extends(Component, _super);
    function Component(props) {
        var _this = _super.call(this, props) || this;
        _this._updating = false;
        _this._update = function () {
            if (!_this._updating) {
                _this._updating = true;
                setTimeout(function () {
                    _this.forceUpdate();
                    _this._updating = false;
                });
            }
        };
        _this._view = new reactive_1.DerivedValue(function () { return _this.view(_this.props); });
        _this._view.dependency.add(_this._update);
        return _this;
    }
    Component.prototype.willMount = function (props) { };
    Component.prototype.componentWillMount = function () {
        this.willMount(this.props);
    };
    Component.prototype.didMount = function (props) { };
    Component.prototype.componentDidMount = function () {
        this.didMount(this.props);
    };
    Component.prototype.willUpdate = function (props) { };
    Component.prototype.componentWillUpdate = function (nextProps) {
        this._view.stale = true;
        this.willUpdate(nextProps);
    };
    Component.prototype.didUpdate = function (props) { };
    Component.prototype.componentDidUpdate = function () {
        this.didUpdate(this.props);
    };
    Component.prototype.willUnmount = function (props) { };
    Component.prototype.componentWillUnmount = function () {
        this.willUnmount(this.props);
        this._view.stop();
        this._view.dependency.delete(this._update);
    };
    Component.prototype.view = function (props) {
        return null;
    };
    Component.prototype.render = function () {
        return this._view.get();
    };
    return Component;
}(react_1.PureComponent));
exports.default = Component;
//# sourceMappingURL=component.js.map